#!/usr/bin/perl
#
######################################################################################
#
# library_test.pl (WebMonitor version 1.0)
#
# Usage: library_test.pl
#
# script just to check whether all the libraries we need are present & which versions
#
# Simply replace the module names below with the ones you use
#
# 02/03/05
#
# Copyright (C) 2005 MyWebAlert!
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
######################################################################################

print `uname -a`;
print `perl -v`;

check_module("DBI");						# all
check_module("DBD::mysql");					# all
check_module("LWP::UserAgent");					# polling/browser emulation (URL, HTTP, POST & all that)
check_module("POSIX");						# signals
check_module("HTTP::Cookies");					# polling/browser emulation
check_module("Fcntl");						# CGI
check_module("CGI");						# CGI
check_module("CGI::Carp");					# CGI
check_module("Time::Local");					# timestamps
check_module("Exporter");					# exporting perl module interfaces
#check_module("vars qw( )");					# exporting perl module interfaces
check_module("Mail::Mailer");					# Email alerts
check_module("Net::DNS");					# DNS checking
check_module("HTTP::Request::Common");				# Inter-site communications - via CGI
check_module("Net::FTP");					# Inter-site communications - FTP
check_module("CGI ':cgi-lib'");					# site synchronisation
check_module("Data::Dumper");					# Dumping data for export
check_module("Digest::MD5");					# Encryption
check_module("URI");						# polling/browser emulation
check_module("Net::Ping");					# ping test
check_module("IO::Socket");					# socket test
check_module("Sys::Hostname");					# hostname test


exit;

######################################################################################
#
# check_module (modulename)
#
# Report if module available of not.
# If it is available, then check the version.
#
######################################################################################

sub check_module {

  my ($module) = @_;
  
  eval "use $module";
  if ($@ ne "") {
     print("module $module LOAD FAILED - $@\n");
  }
  else {
     $version = getversion($module);
     print "module $module OK; version: $version\n";
  }   
}

######################################################################################
#
# getversion (modulename)
#
# Run Perl to load the module and print its verson number, redirecting
# errors to /dev/null
#
######################################################################################

sub getversion {
    my $mod = shift;

    my $vers = `$^X -m$mod -e 'print \$${mod}::VERSION' 2>/dev/null`;
    $vers =~ s/^\s*(.*?)\s*$/$1/; # remove stray whitespace
    return ($vers || undef);
}
